#include "Task.h"

#include "devProperties.h"
//#include "mcuRegistersDma.h"
//#include "mcuRegistersDmaMux.h"
#include "mcuRegistersFtm.h"
#include "mcuRegistersSim.h"

//#include <mqx.h>
//#include <bsp.h>
//#include <shell.h>

extern "C"
{
	void FlexTimerCapturingInitial();

	void TaskFreq(uint_32 data)
	{
		dev::tProperties *Properties = (dev::tProperties*)data;

		unsigned short FtmResult[10];
		unsigned short FtmResultIndex = 0;;

		memset(FtmResult, 0, sizeof(FtmResult));

		FlexTimerCapturingInitial();

		FTM_MemMapPtr FtmMmp = FTM0_BASE_PTR;

		mcu::registers::ftm::tSC* SC = (mcu::registers::ftm::tSC*)&FtmMmp->SC;

		mcu::registers::ftm::tCSC* Csc0 = (mcu::registers::ftm::tCSC*)&FtmMmp->CONTROLS[0].CnSC;
		//mcu::registers::ftm::tCSC* Csc1 = (mcu::registers::ftm::tCSC*)&FtmMmp->CONTROLS[1].CnSC;

		mcu::registers::ftm::tCNT* Cnt = (mcu::registers::ftm::tCNT*)&FtmMmp->CNT;

		mcu::registers::ftm::tCV* Cv0 = (mcu::registers::ftm::tCV*)&FtmMmp->CONTROLS[0].CnV;
		//mcu::registers::ftm::tCV* Cv1 = (mcu::registers::ftm::tCV*)&FtmMmp->CONTROLS[1].CnV;

		memset(FtmResult, 0, sizeof(FtmResult));

		for (;;)
		{
			Cnt->Fields.CNT = 0;
			Csc0->Fields.CHF = 0;
			while(!Csc0->Fields.CHF);

			if(SC->Fields.TOF)
			{
				SC->Fields.TOF = 0;
				continue;
			}

			FtmResult[FtmResultIndex++] = Cv0->Fields.VAL;

			if (FtmResultIndex >= sizeof(FtmResult) / 2)
			{
				printf(">>");
				for (int i = 0; i < FtmResultIndex; ++i)
					printf(" %04x ", FtmResult[i]);
				printf("\n");
				_time_delay(1000);

				memset(FtmResult, 0, sizeof(FtmResult));
				FtmResultIndex = 0;
			}

			//if (Csc0->Fields.CHF)//This bit is set when the counter value is captured into CnV
			//{
			//	printf("Ch1: %04x ",Cv0->Fields.VAL);
			//}

			//if (Csc1->Fields.CHF)//This bit is set when the counter value is captured into CnV
			//{
			//	printf("Ch2: %04x ",Cv1->Fields.VAL);
			//}

			//printf("\xd");

			//_time_delay(1000);
		}

		//_task_abort(TaskPort);
		//_task_destroy(TaskPort);

		//_time_delay(1000); // 1 s

		//_task_restart(_task_get_id(), &data, 0);
	}

	void FlexTimerCapturingInitial()
	{
		PORT_MemMapPtr PCtlMmp = (PORT_MemMapPtr)PORTC_BASE_PTR;
		SIM_MemMapPtr SimMmp = SIM_BASE_PTR;
		FTM_MemMapPtr FtmMmp = FTM0_BASE_PTR;

		PCtlMmp->PCR[1] = PORT_PCR_MUX(4);
		PCtlMmp->PCR[2] = PORT_PCR_MUX(4);

		//Enable clock to FlexTimer module
		mcu::registers::sim::tSCGC6* SimScgc6 = (mcu::registers::sim::tSCGC6*)&SimMmp->SCGC6;
		SimScgc6->Fields.FTM0 = 1;//Enable clock to FlexTimer module

		mcu::registers::sim::tSOPT4* SimSopt4 = (mcu::registers::sim::tSOPT4*)&SimMmp->SOPT4;//It seems to be in order.

		//Captured frequencies are from 100 Hz up to 1600 Hz.
		//The FTM has a 16-bit counter.

		mcu::registers::ftm::tSC* SC = (mcu::registers::ftm::tSC*)&FtmMmp->SC;
		mcu::registers::ftm::tMODE* Mode = (mcu::registers::ftm::tMODE*)&FtmMmp->MODE;

		//SC->Fields.TOIE = 0;//Disable Timer Overflow Interrupts (Default)
		//SC->Fields.CPWMS = 0;//FTM counter operates in up counting mode (Default)

		//Mode->Fields.WPDIS = 1;//Write Protection Disable (Default)

		//mcu::registers::ftm::tCOMBINE* Combine = (mcu::registers::ftm::tCOMBINE*)&FtmMmp->COMBINE;//It seems to be in order.

		mcu::registers::ftm::tCNTIN* Cntin = (mcu::registers::ftm::tCNTIN*)&FtmMmp->CNTIN;
		Cntin->Fields.INIT = 0x0000;//It is expected that the input capture mode be used only with CNTIN = 0x0000;

		mcu::registers::ftm::tMOD* Mod = (mcu::registers::ftm::tMOD*)&FtmMmp->MOD;
		Mod->Fields.MOD = 0xFFFF;

		mcu::registers::ftm::tCSC* Csc0 = (mcu::registers::ftm::tCSC*)&FtmMmp->CONTROLS[0].CnSC;

//		Csc0->Fields.DMA = 1;
		//Csc0->Fields.CHIE = 0;//Interrupts are disabled (Default)
		//Csc0->Fields.MSA = 0; (Default)
		//Csc0->Fields.MSB = 0; (Default)
		Csc0->Fields.ELSA = 1;//Capture on Rising Edge
		//Csc0->Fields.ELSB = 0;//Do not capture on Falling Edge (Default)

		mcu::registers::ftm::tCSC* Csc1 = (mcu::registers::ftm::tCSC*)&FtmMmp->CONTROLS[1].CnSC;

		//Csc1->Fields.DMA = 1;
		//Csc1->Fields.CHIE = 0;//Interrupts are disabled (Default)
		Csc1->Fields.ELSA = 1;//Capture on Rising Edge
		//Csc1->Fields.ELSB = 0;//Do not capture on Falling Edge (Default)

		///////////////////////////////////////////////////////////////////////////////////////////

		Mode->Fields.FTMEN = 1;//FTM Enable. All registers including the FTM-specific registers (second set of registers) are available for use with no restrictions.

		SC->Fields.CLKS = 0x01;//System Clock 100 Mhz
		SC->Fields.PS = 0x07;//divide by 128 -> 781250 Hz = 0xBEBC2
		// 781250 / 100 (min freq of DUT) = 7812.50 and that is less than 0xFFFF, so it's good! :)
	}
}
